﻿#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
#define all(v) v.begin(), v.end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, k; cin >> n >> k;
    vector<int>cnt(k);
    for (int i = 0; i < k; i++) {
        cin >> cnt[i];
    }
    vector<int>used(n);
    for (int i = 0; i < n; i++) {
        int cur_pos = i;
        bool suit = true;
        for (int j = 0; j < k; j++) {
            cur_pos += cnt[j];
            if (cur_pos < 0 || cur_pos > n - 1) {
                suit = false;
                break;
            }
        }
        if (suit) {
            used[i] = 1;
        }
    }
    int l = -1;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            l = i;
            break;
        }
    }
    int r = -1;
    for (int i = n - 1; i >= 0; i--) {
        if (used[i]) {
            r = i;
            break;
        }
    }
    cout << l + 1 << " " << r + 1 << "\n";
}