from math import ceil
from itertools import product

n, k = map(int, input().split())

planes = list(map(int, input().split()))
maxes = [ceil(n / p) for p in planes]

answers = []

current = [0] * len(planes)

for pr in product(*(range(m + 1) for m in maxes)):
    free = sum(pr[i] * planes[i] for i in range(len(pr))) - n
    if free >= 0:
        answers.append((free, sum(pr), pr))

ans = min(answers)
print(ans[0])
print(*ans[2])
