'''
7
abcd efgh IJKL
a bcdf bfhg knml
b bcaacbabh ab cbc
xyz zyx xxxxxxx z
a aaaaaaaaa a
uio ooooooo z k f
f dfgh dfgi rrt

a bcdf bfhg knml
b bcaacbabh ab cbc
a aaaaaaaaa a
f dfgh dfgi rrt
'''

'''
7
a b c d
aaaaaaa
a b c d
aaaaaaa
a b c d
aaaaaaa
aaaaaaa
'''

n = int(input())

all_spaces = []
for _ in range(n):
    string = input()
    spaces = set()
    for i in range(len(string)):
        if string[i] == ' ':
            spaces.add(i)
    all_spaces.append(spaces)

intersections = set()
for i in range(n - 1):
    for j in range(i + 1, n):
        inter = frozenset(all_spaces[i].intersection(all_spaces[j]))
        if len(inter) > 1:
            intersections.add(inter)

possible_results = []
counter = 0
max_len = 0
has_max_len = None
for inter in intersections:
    cur_res = []
    cur_len = 0
    for i, elem in enumerate(all_spaces):
        if inter.issubset(elem):
            cur_res.append(i + 1)
            cur_len += 1
    if cur_len > 0:
        possible_results.append(cur_res)
        if cur_len > max_len:
            max_len = cur_len
            has_max_len = counter
        counter += 1
if has_max_len is not None:
    print(*possible_results[has_max_len], sep='\n')
else:
    print(0)

