'''
bmstu.ru jpg png docx
<body>
<a href="http://bmstu.ru/in<d>ex">Link1</a>
<a href="https://olymp.bmstu.ru/index">http://olymp.bmstu.ru/a.jpg</a>
<img src="index/abc.docx">Link1</a>
<a href="bmstu.ru/index.jpg">Link1</a>
<a href="www.bmstu.ru/c.png">Link1</a>
<img src="bmstu.net/d.jpg">Link1</a>
<img src="/d.jpg">Link1</a>
<img src="/d.lol#123.kek">Link1</a>
/lol.png?really=false <!-- Внутри тега body -->
<a href="false-link.com/test.png">
/test.png
test.png <!-- Ссылка на сайт, а не на файл -->
</a>
</body>
.
'''

def analyze_link(pure_link):
    q_ind = pure_link.find('?')
    s_ind = pure_link.find('#')

    if q_ind != -1 and s_ind != -1:
        link = pure_link[:min(q_ind, s_ind)]
    elif q_ind != -1:
        link = pure_link[:q_ind]
    elif s_ind != -1:
        link = pure_link[:s_ind]
    else:
        link = pure_link

    if link.startswith('/'):
        ind = link.rfind('.')
        format_ = link[ind + 1:]
        if (ind == -1 or format_ in formats or '/' in format_):
            result.append(pure_link)
            return
    if '.' in link:
        if domain_name in link:
            ind = link.rfind('.')
            format_ = link[ind + 1:]
            if (ind == -1 or format_ in formats or '/' in format_):
                result.append(pure_link)
                return
    if '/' in link:
        page = link[:link.find('/')]
        if '.' not in page or domain_name in page:
            ind = link.rfind('.')
            format_ = link[ind + 1:]
            if (ind == -1 or format_ in formats or '/' in format_):
                result.append(pure_link)
                return


data = input().split()
domain_name = data[0]
formats = set(data[1:])

result = []

attr_data = ''
is_tag = False
is_attr = False
opening_tag_count = 0

while True:
    string = input()
    outside_tag_data = ''

    if string == '.':
        break

    for i, symbol in enumerate(string):
        if symbol == '<' and not is_attr:
            if i < len(string) - 1 and string[i + 1] == '/':
                opening_tag_count -= 1
            else:
                opening_tag_count += 1

            is_tag = True
            if outside_tag_data:
                analyze_link(outside_tag_data)
                outside_tag_data = ''
        elif symbol == '>' and not is_attr:
            is_tag = False
        elif symbol == '"' and i != 0 and string[i - 1] == '=' and is_tag:
            is_attr = True
        elif symbol == '"' and is_attr:
            is_attr = False
            analyze_link(attr_data)
            attr_data = ''
        else:
            if not is_tag and opening_tag_count > 0:
                outside_tag_data += symbol
            if is_attr:
                attr_data += symbol

    if outside_tag_data:
        analyze_link(outside_tag_data)

print(*result, sep='\n')
