def analyzer(n):
    if '+' in n:
        a_alien, b_alien = n.split('+')
        type = 0
    elif '-' in n:
        a_alien, b_alien = n.split('-')
        type = 1
    elif '*' in n:
        a_alien, b_alien = n.split('*')
        type = 2
    else:
        a_alien, b_alien = n.split('/')
        type = 3
    return a_alien, b_alien, type


def translator(a_alien):
    n = len(a_alien)
    a_ours = 0
    for i in range(n):
        if a_alien[i] == '1':
            a_ours += 3 ** (n - i - 1)
        elif a_alien[i] == 'a':
            a_ours -= 3 ** (n - i - 1)
    return a_ours


def calculator(a, b, type):
    if type == 0:
        c = a + b
    elif type == 1:
        c = a - b
    elif type == 2:
        c = a * b
    if type == 3:
        c = a // b
    return c


def retranslator(a_ours):
    a_alien_list = []
    if a_ours == 0:
        return '0'
    else:
        while a_ours != 0:
            if a_ours % 3 == 0:
                a_alien_list.append('0')
                a_ours = a_ours // 3
            elif a_ours % 3 == 1:
                a_alien_list.append('1')
                a_ours = a_ours // 3
            elif a_ours % 3 == 2:
                a_alien_list.append('a')
                a_ours = (a_ours + 1) // 3
        a_alien_list.reverse()
        a_alien = ''.join(a_alien_list)
        return a_alien


n = input()
a_alien, b_alien, type = analyzer(n)
a_ours = translator(a_alien)
b_ours = translator(b_alien)
c_ours = calculator(a_ours, b_ours, type)
c_alien = retranslator(c_ours)
print(c_alien)
