#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    string a, c;
    int k;
    cin >> a >> k >> c;
    string x = "";
    for (int i = 0; i < a.size(); ++i) {
        int ci = 0;
        if ('0' <= a[i] && a[i] <= '9') {
            ci = a[i] - '0';
        } else {
            ci = 10 + (a[i] - 'A');
        }
        if (ci >= 8) {
            x += '1';
            ci -= 8;
        } else {
            x += '0';
        }
        if (ci >= 4) {
            x += '1';
            ci -= 4;
        } else {
            x += '0';
        }
        if (ci >= 2) {
            x += '1';
            ci -= 2;
        } else {
            x += '0';
        }
        if (ci >= 1) {
            x += '1';
            ci -= 1;
        } else {
            x += '0';
        }
    }

    string res = "";
    for (int i = 0; i < c.size(); ++i) {
        int ci = 0;
        if ('0' <= c[i] && c[i] <= '9') {
            ci = c[i] - '0';
        } else {
            ci = 10 + (c[i] - 'A');
        }
        if (ci >= 8) {
            res += '1';
            ci -= 8;
        } else {
            res += '0';
        }
        if (ci >= 4) {
            res += '1';
            ci -= 4;
        } else {
            res += '0';
        }
        if (ci >= 2) {
            res += '1';
            ci -= 2;
        } else {
            res += '0';
        }
        if (ci >= 1) {
            res += '1';
            ci -= 1;
        } else {
            res += '0';
        }
    }

    //cout << c << endl;
    //cout << res << endl;

    k %= int(res.size());

    string res1 = "";
    for (int i = 0; i < int(res.size()); ++i) {
        int j = i - k;
        if (j < 0) {
            j += res.size();
        }
        res1 += res[j];
    }
    //cout << res1 << endl;

    int fir = 0, ans = 0;
    int p = 1;
    for (int i = x.size() - 1; i >= 0; --i) {
        fir += (x[i] - '0') * p;
        p *= 2;
    }
    p = 1;
    for (int i = res1.size() - 1; i >= 0; --i) {
        ans += (res1[i] - '0') * p;
        p *= 2;
    }
    int sec = (fir ^ ans);
    string y = "";
    while (sec > 0) {
        if (sec % 2 == 0) {
            y += '0';
        } else {
            y += '1';
        }
        sec /= 2;
    }
    reverse(y.begin(), y.end());
    if (y.size() == 0) {
        cout << 0;
        return 0;
    }
    string otv = "";
    for (int i = y.size() - 1; i >= 0; i -= 4) {
        int tmp = (y[i] - '0') * 1;
        if (i - 1 >= 0) {
            tmp += (y[i - 1] - '0') * 2;
        }
        if (i - 2 >= 0) {
            tmp += (y[i - 2] - '0') * 4;
        }
        if (i - 3 >= 0) {
            tmp += (y[i - 3] - '0') * 8;
        }
        if (tmp < 10) {
            otv += char(int('0') + tmp);
        } else {
            tmp -= 10;
            otv += char(int('A') + tmp);
        }
    }
    reverse(otv.begin(), otv.end());
    cout << otv;
}
