#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <algorithm>

using namespace std;

const int INF = 1e9;

int dp[110][1000010];
int ok[110][1000010];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n, m, x;
    cin >> n >> m >> x;
    map<string, int> pr;
    vector<string> names;
    vector<int> v(n), cnt(n);
    for (int i = 0; i < n; ++i) {
        string s;
        int k;
        cin >> s >> k;
        pr[s] = i;
        v[i] = k;
        names.push_back(s);
    }
    for (int i = 0; i < m; ++i) {
        string s;
        vector<string> a;
        int y;
        while (cin >> s) {
            if ('0' <= s[0] && s[0] <= '9') {
                y = stoi(s);
                break;
            }
            a.push_back(s);
        }
        for (int i = 0; i < a.size(); ++i) {
            cnt[pr[a[i]]] += y;
        }
    }
    //for (auto el : pr) {
    //    cout << el.first << ' ' << cnt[el.second] << endl;
    //}
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= x; ++j) {
            dp[i][j] = -INF;
        }
    }
    dp[0][0] = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j <= x; ++j) {
            dp[i + 1][j] = max(dp[i + 1][j], dp[i][j]);
            if (j - v[i] >= 0 && dp[i][j - v[i]] + cnt[i] > dp[i + 1][j]) {
                dp[i + 1][j] = dp[i][j - v[i]] + cnt[i];
                ok[i + 1][j] = 1;
            }
        }
    }
    int mx = 0;
    for (int i = x; i >= 0; --i) {
        if (dp[n][i] > mx) {
            mx = dp[n][i];
        }
    }
    for (int i = x; i >= 0; --i) {
        if (dp[n][i] == mx) {
            vector<int> ans;
            int ind = n, k = i;
            while (ind > 0) {
                if (ok[ind][k]) {
                    ans.push_back(ind - 1);
                    k -= v[ind - 1];
                }
                ind--;
            }
            cout << ans.size() << '\n';
            for (int i = int(ans.size()) - 1; i >= 0; --i) {
                cout << names[ans[i]] << '\n';
            }
            return 0;
        }
    }
}
