//#include "stdafx.h"

#include <unordered_map>
#include <iostream>
#include <string>
#include <vector>

using namespace std;

int n, m, x, bcol = 0;
vector <pair <string, int>> size;
unordered_map <string, int> col;
vector <string> best, cur;

void solve(int it = 0, int s = 0, int v = 0){
	if (v > bcol){
		bcol = v;
		best = cur;
	}
	for (int i = it; i < n; i++){
		if (s + size[i].second <= x){
			cur.push_back(size[i].first);
			solve(i + 1, s + size[i].second, v + col[size[i].first]);
			cur.pop_back();
		}
	}
}

int main(){
	ios_base::sync_with_stdio(0);
	string buffer;
	getline(cin, buffer);
	n = atoi(buffer.substr(0, buffer.find(' ')).c_str());
	m = atoi(buffer.substr(buffer.find(' ') + 1, buffer.rfind(' ') - buffer.find(' ') - 1).c_str());
	x = atoi(buffer.substr(buffer.rfind(' ') + 1).c_str());
	size.resize(n);
	for (int i = 0; i < n; i++){
		getline(cin, buffer);
		size[i].first = buffer.substr(0, buffer.find(' '));
		size[i].second = atoi(buffer.substr(buffer.find(' ') + 1).c_str());
	}
	vector <string> sr;
	int coll;
	for (int i = 0; i < m; i++){
		getline(cin, buffer);
		while (buffer.find(' ') != -1){
			sr.push_back(buffer.substr(0, buffer.find(' ')));
			buffer.erase(0, buffer.find(' ') + 1);
		}
		coll = atoi(buffer.c_str());
		for (const string str : sr){
			col[str] += coll;
		}
		sr.clear();
	}
	solve();
	cout << best.size() << '\n';
	for (const string str : best) cout << str << '\n';
	return 0;
}
