

#include <iostream>
#include <cmath>
#include <numeric>
#include <algorithm>
#include <vector>
#include <map>
#include <set>

using namespace std;

map<string, vector<string>> mp;
int n;

set<vector<string>> ans_list;

void gen(vector<string> calls) {
	if (calls.size() <= n) {
		ans_list.insert(calls);
	} else {
		return;
	}
	for (auto& el : mp[*calls.rbegin()]) {
		calls.push_back(el);
		gen(calls);
		calls.pop_back();
	}
}

int main() {
	cin >> n;
	string s;
	cin >> s;
	while (s != ".") {
		string name;
		cin >> name;
		mp[name] = {};
		string temp;
		cin >> temp;
		while (temp != "ENDFUNC") {
			string call_name;
			cin >> call_name;
			mp[name].push_back(call_name);
			cin >> temp;
		}
		cin >> s;
	}
	vector<string> calls;
	for (auto& el : mp["MAIN"]) {
		calls.push_back(el);
		gen(calls);
		calls.pop_back();
	}
	cout << ans_list.size() << '\n';
	for (auto& lists : ans_list) {
		for (auto& el : lists) {
			cout << el << ' ';
		}
		cout << '\n';
	}
    return 0;
}
