#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
#define all(v) v.begin(), v.end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n; cin >> n;
    string s; getline(cin, s);
    vector<string>strs(n);
    vector<int>spaces;
    for (int i = 0; i < n; i++) {
        getline(cin, s);
        strs[i] = s;
        for (int j = 0; j < s.size(); j++) {
            if (s[j] == ' ') {
                spaces.push_back(j);
            }
        }
    }
    sort(all(spaces));
    spaces.resize(unique(all(spaces)) - spaces.begin());
    pair<int, int>best_space;
    int cnt_best = 0;
    for (int i = 0; i < spaces.size(); i++) {
        for (int j = i + 1; j < spaces.size(); j++) {
            int cur_cnt = 0;
            for (int k = 0; k < n; k++) {
                if (strs[k].size() <= spaces[i] || strs[k].size() <= spaces[j]) {
                    continue;
                }
                if (strs[k][spaces[i]] == ' ' && strs[k][spaces[j]] == ' ') {
                    cur_cnt++;
                }
            }
            if (cur_cnt > cnt_best) {
                cnt_best = cur_cnt;
                best_space = { spaces[i], spaces[j] };
            }
        }
    }
    vector<int>answers;
    for (int i = 0; i < n; i++) {
        if (strs[i].size() <= best_space.first || strs[i].size() <= best_space.second) {
            continue;
        }
        if (strs[i][best_space.first] == ' ' && strs[i][best_space.second] == ' ') {
            answers.push_back(i + 1);
        }
    }
    if (answers.size() < 2) {
        cout << 0 << "\n";
    }
    else if (answers.size() < ceil(n / 2.0)) {
        cout << 0 << "\n";
    }
    else {
        for (auto it : answers) {
            cout << it << "\n";
        }
    }
}