#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
#define all(v) v.begin(), v.end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n; cin >> n;
    vector<vector<int>>a(n, vector<int>(n));
    vector<vector<int>>used(n, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> a[i][j];
        }
    }
    int i = 0, j = n - 1;
    cout << a[i][j] << " ";
    if (n % 2 == 1) {
        while (i != n - 1 || j != n - 1) {
            i++;
            cout << a[i][j] << " ";
            while (i > 0 && j > 0) {
                i--; j--;
                cout << a[i][j] << " ";
            }
            j--;
            cout << a[i][j] << " ";
            while (i < n - 1 && j < n - 1) {
                i++; j++;
                cout << a[i][j] << " ";
            }
        }
        while (i != n - 1 || j != 0) {
            j--;
            cout << a[i][j] << " ";
            while (i > 0 && j > 0) {
                i--; j--;
                cout << a[i][j] << " ";
            }
            i++;
            cout << a[i][j] << " ";
            while (i < n - 1 && j < n - 1) {
                i++; j++;
                cout << a[i][j] << " ";
            }
        }
    }
    else {
        while (i != 0 || j != 0) {
            i++;
            cout << a[i][j] << " ";
            while (i > 0 && j > 0) {
                i--; j--;
                cout << a[i][j] << " ";
            }
            if (i == 0 && j == 0) {
                break;
            }
            j--;
            cout << a[i][j] << " ";
            while (i < n - 1 && j < n - 1) {
                i++; j++;
                cout << a[i][j] << " ";
            }
        }
        int d = 1;
        while (i != n - 1 || j != 0) {
            i++;
            cout << a[i][j] << " ";
            while (i < n - 1 && j < n - 1) {
                i++; j++;
                cout << a[i][j] << " ";
            }
            if (i == n - 1 && j == 0) {
                break;
            }
            j--;
            cout << a[i][j] << " ";
            while (i > 0 && j > 0) {
                i--; j--;
                cout << a[i][j] << " ";
            }
        }
    }
}

