#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <chrono>
#include <random>
#include <set>
#include <map>
#include <string>
#include <queue>
using namespace std;
typedef long long ll;
#define all(v) v.begin(), v.end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

string get_domen(string s) {
    string domen = "";
    bool found = false;
    for (int i = 0; i < (int)s.size() - 2; i++) {
        if (s[i] == ':' && s[i + 1] == '/' && s[i + 2] == '/') {
            i += 3;
            found = true;
        }
        if (found) {
            domen += s[i];
        }
    }
    if (domen != "") {
        for (int i = s.size() - 2; i < s.size(); i++) {
            domen += s[i];
        }
        for (int i = domen.size() - 1; i >= 0; i--) {
            if (domen[i] == '/') {
                bool point = false;
                for (int j = i + 1; j < domen.size(); j++) {
                    if (domen[j] == '.') {
                        point = true;
                        break;
                    }
                }
                if (point) {
                    domen.erase(domen.begin() + i, domen.end());
                }
            }
        }
        return domen;
    }
    else {
        for (int i = 0; i < (int)s.size(); i++) {
            if (s[i] != '/') {
                domen += s[i];
            }
            else {
                break;
            }
        }
        return domen;
    }
}

string get_type(string c) { // jpg, none...
    string sub = "";
    for (int i = c.size() - 1; i >= 0; i--) {
        if (c[i] == '/') {
            for (int j = i + 1; j < c.size(); j++) {
                sub += c[j];
            }
            break;
        }
    }
    bool found_point = false;
    string after_point = "";
    for (int i = 0; i < sub.size(); i++) {
        if (sub[i] == '.') {
            found_point = true;
        }
        else if (found_point) {
            after_point += sub[i];
        }
    }
    return after_point;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string temp; getline(cin, temp);
    string domen = "";
    int last = temp.size();
    for (int i = 0; i < temp.size(); i++) {
        if (temp[i] == ' ') {
            last = i + 1;
            break;
        }
        domen += temp[i];
    }
    vector<string>files;
    string cur = "";
    for (int i = last; i < temp.size(); i++) {
        if (temp[i] == ' ') {
            files.push_back(cur);
            cur = "";
        }
        else {
            cur += temp[i];
        }
    }
    files.push_back(cur);
    vector<string>think;
    vector<string>to;
    while (true) {
        string s; getline(cin, s);
        if (s == ".") {
            break;
        }
        cur = "";
        bool opened = false;
        for (int i = 0; i < s.size(); i++) {
            if (s[i] == '"' && !opened) {
                opened = true;
            }
            else if (s[i] == '"' && opened) {
                think.push_back(cur);
            }
            else if(opened){
                cur += s[i];
            }
        }
        opened = false;
        cur = "";
        for (int i = 0; i < s.size(); i++) {
            if (s[i] == '>' && !opened) {
                opened = true;
            }
            else if (s[i] == '<' && opened) {
                think.push_back(cur);
            }
            else if (opened) {
                cur += s[i];
            }
        }
    }
    set<string>domens;
    domens.insert(domen);
    for (auto c : think) {
        if (c.find("Link") != -1) {
            continue;
        }
        else if (c.find(".net") != -1) {
            continue;
        }
        cout << c << "\n";
    }
}