n, m, x = map(int, input().split())

items = []
index = {}

for i in range(n):
    name, memory = input().split()
    items.append([name, int(memory), 0])

    index[name] = i
    
for _ in range(m):
    *names, count = input().split()
    count = int(count)
    for name in names:
        items[index[name]][2] += count

backpack = {0: (0, [])}

for name, weight, calls in items:
    nb = {}
    for w in backpack:
        if w + weight <= x:
            nb[w + weight] = max(backpack.get(w + weight, (0, [])), (backpack[w][0] + calls, backpack[w][1] + [name]))
    backpack.update(nb)

ans = max(backpack.values())
print(len(ans[1]))
print(*ans[1], sep="\n")
