#pragma GCC optimize("fast-math")
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <iostream>
#include <string>


using namespace std;

#define F first
#define S second
#define ll long long
string s;
string ans = "";
string ans1 = "";

void dfs(ll v, ll sum, ll last, bool fl)
{
    if (v == s.length())
    {
        if (fl)
            sum += last;
        else
            sum -= last;
        if (sum == 0 && (ans1 == "" || ans1.length() > ans.length()))
            ans1 = ans;
        return;
    }
    if (v == 0)
    {
        ans += s[v];
        dfs(v + 1, sum, s[v] - '0', 1);
        ans.pop_back();
        return;
    }
    ans += s[v];
    dfs(v + 1, sum, last * 10 + s[v] - '0', fl);
    ans.pop_back();
    if (fl)
        sum += last;
    else
        sum -= last;
    ans += '+';
    ans += s[v];
    dfs(v + 1, sum, s[v] - '0', 1);
    ans.pop_back();
    ans.pop_back();

    ans += '-';
    ans += s[v];
    dfs(v + 1, sum, s[v] - '0', 0);
    ans.pop_back();
    ans.pop_back();

    return;
}



void dfs1(ll v, ll sum)
{
    if (v == s.length())
    {
        if (sum == 0 && ans1 == "")
            ans1 = ans;
        return;
    }
    if (v == 0)
    {
        ans += s[v];
        dfs1(v + 1, sum + s[v] - '0');
        ans.pop_back();
    }
    else
    {
        ans += '+';
        ans += s[v];
        dfs1(v + 1, sum + s[v] - '0');
        ans.pop_back();
        ans.pop_back();
    }
    ans += '-';
    ans += s[v];
    dfs1(v + 1, sum - (s[v] - '0'));
    ans.pop_back();
    ans.pop_back();
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> s;
    if (s.length() <= 15)
        dfs(0, 0, 0, 0);
    else
        dfs1(0, 0);
    if (ans1 != "")
        cout << ans1;
    else
        cout << "NO";
}

