//#include "stdafx.h"

#include <algorithm>
#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>

using namespace std;

struct star{
	int x, y, z;
	int num;
};

vector <star> ss;
vector <int> s, bs;
int cnt;
long double best = 0.0;
int x, y, z;
int x1, Y1, z1;

bool sort(star a1, star a2){
	return (sqrt((a1.x - x) * (a1.x - x) + (a1.y - y) * (a1.y - y) + (a1.z - z) * (a1.z - z)) < sqrt((a2.x - x) * (a2.x - x) + (a2.y - y) * (a2.y - y) + (a2.z - z) * (a2.z - z)));
}

bool rass(star a1){
	return (sqrt((a1.x - x) * (a1.x - x) + (a1.y - y) * (a1.y - y) + (a1.z - z) * (a1.z - z)) <= 20.0);
}

bool punkt(star a1){
	long double A = sqrt((a1.x - x) * (a1.x - x) + (a1.y - y) * (a1.y - y) + (a1.z - z) * (a1.z - z));
	long double B = sqrt((a1.x - x1) * (a1.x - x1) + (a1.y - Y1) * (a1.y - Y1) + (a1.z - z1) * (a1.z - z1));
	long double C = sqrt((x1 - x) * (x1 - x) + (Y1 - y) * (Y1 - y) + (z1 - z) * (z1 - z));
	long double P = (A + B + C) / 2;
	long double S = sqrt(P * (P - A) * (P - B) * (P - C));
	long double H = 2 * S / A;
	return (H < 1);
}

long double rasss(star a1){
	return sqrt((a1.x - x) * (a1.x - x) + (a1.y - y) * (a1.y - y) + (a1.z - z) * (a1.z - z));
}

void check(int xx = 0, int yy = 0, int zz = 0, int it = 0, long double ras = 0.0, bool f1 = false, bool f2 = false, bool f3 = false, vector <star> temp = ss){
	if (f1 && f2 && f3){
		if (abs(best) < 0.000001 || s.size() < bs.size() || (s.size() == bs.size() && best > ras)){
			best = ras;
			bs = s;
		}
		return;
	}
	if (it == cnt) return;
	x = xx, y = yy, z = zz;
	for (int i = it; i < cnt - 1; i++){
		for (int j = i + 1; j < cnt; j++){
			if (!sort(temp[i], temp[j])) swap(temp[i], temp[j]);
		}
	}
	bool flag = false;
	for (int i = it; i < cnt; i++){
		x = xx, y = yy, z = zz;
		if (!rass(temp[i])) break;
		flag = false;
		for (int j = it; j < i; j++){
			x1 = temp[j].x;
			Y1 = temp[j].y;
			z1 = temp[j].z;
			if (punkt(temp[i])){
				flag = true;
				break;
			}
		}
		if (flag) break;
		if (temp[i].num == 1) f1 = true;
		if (temp[i].num == 2) f2 = true;
		if (temp[i].num == 3) f3 = true;
		s.push_back(temp[i].num);
		check(temp[i].x, temp[i].y, temp[i].z, i + 1, ras + rasss(temp[i]), f1, f2, f3, temp);
		if (temp[i].num == 1) f1 = false;
		if (temp[i].num == 2) f2 = false;
		if (temp[i].num == 3) f3 = false;
		s.pop_back();
	}
}

int main(){
	ios_base::sync_with_stdio(0);
	cin >> cnt;
	ss.resize(cnt);
	for (int i = 0; i < cnt; i++){
		ss[i].num = i + 1;
		cin >> ss[i].x >> ss[i].y >> ss[i].z;
	}
	check();
	cout << bs.size() << ' ' << fixed << setprecision(3) << best << '\n';
	for (const int it : bs) cout << it << ' ';
	return 0;
}
