#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

bool is_op(char x){
    return x == '+' || x == '-' || x == '/' || x == '*';
}

int to_num(string num){
    reverse(num.begin(), num.end());

    int res = 0;
    int three = 1;
    for(int i = 0; i < (int)num.size(); ++i){
        if(num[i] == 'a'){
            res -= three;
        }
        else if(num[i] == '1'){
            res += three;
        }

        three *= 3;
    }

    return res;
}

string to_str(int x){
    if(x == 0)
        return "0";
    bool to_change = false;
    if(x < 0)
        to_change = true;
    string s;

    x = abs(x);
    while(x > 0){
        int r = x % 3;
        int q = x / 3;

        if(r <= 1){
            s += r + '0';
            x = q;
        }
        else{
            s += 'a';
            q++;
            x = q;
        }
    }
    reverse(s.begin(), s.end());

    if(to_change){
        for(int i = 0; i < (int)s.size(); ++i){
            if(s[i] == 'a')
                s[i] = '1';
            else if(s[i] == '1')
                s[i] = 'a';
        }
    }
    return s;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

    string line;
    cin >> line;

    string num1, num2;
    char op;
    bool two = false;
    for(int i = 0; i < (int)line.size(); ++i){
        if(is_op(line[i])){
            op = line[i];
            two = true;
        }
        else if(!two){
            num1 += line[i];
        }
        else{
            num2 += line[i];
        }
    }

    int result = 0;
    if(op == '+')
        result = to_num(num1) + to_num(num2);
    else if(op == '-')
        result = to_num(num1) - to_num(num2);
    else if(op == '*')
        result = to_num(num1) * to_num(num2);
    else
        result = to_num(num1) / to_num(num2);

    cout << to_str(result);
}
