#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;


int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

    int n, k;
    cin >> n >> k;

    vector<int> a(n);
    for(int i = 0; i < k; ++i){
        cin >> a[i];
    }

    int min_st = n + 1;
    int max_st = 0;
    for(int i = 1; i <= n; ++i){
        int st = i;
        bool poss = true;
        for(int j = 0; j < k; ++j){
            st += a[j];
            if(st > n || st < 1)
                poss = false;
        }

        if(poss){
            min_st = min(min_st, i);
            max_st = max(max_st, i);
        }
    }


    cout << min_st << ' ' << max_st;
}
