#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
using namespace std;

string to_upper(string s) {
	string res;
	for (int i = 0; i < (int)s.size(); ++i) {
		if (isalpha(s[i]) && islower(s[i]))
			res += char(s[i] - 32);
		else
			res += s[i];
	}

	return res;
}


int main()
{
	//ios_base::sync_with_stdio(0);
	//cin.tie(0);
	//cout.tie(0);

	int n;
	cin >> n;


	map<pair<string, string>, int> name_cnt;
	for (int t = 0; t < n; ++t) {
		string s;
		cin >> s;
		s = to_upper(s);

		string name, type;
		int i = 0;
		for (i; i < (int)s.size(); ++i) {
			if (s[i] == '.')
				break;
			name += s[i];
		}
		for (i; i < (int)s.size(); ++i) {
			type += s[i];
		}

		if (s.size() <= 12) {
			while (name.size() > 8)
				name.pop_back();

			if (name_cnt[{name, type}] == 0) {
				name_cnt[{name, type}]++;
				cout << s << endl;
			}
			else if (name_cnt[{name, type}] < 9) {
				while (name.size() > 6)
					name.pop_back();
				name_cnt[{name, type}]++;
				cout << name << '~' << name_cnt[{name, type}] << type << endl;
			}
			else {
				while (name.size() > 5)
					name.pop_back();
				name_cnt[{name, type}]++;
				cout << name << '~' << name_cnt[{name, type}] << type << endl;
			}
		}
		else {
			while (name.size() > 6)
				name.pop_back();

			if (name_cnt[{name, type}] < 9) {
				name_cnt[{name, type}]++;
				cout << name << '~' << name_cnt[{name, type}] << type << endl;
			}
			else {
				name.pop_back();
				name_cnt[{name, type}]++;
				cout << name << '~' << name_cnt[{name, type}] << type << endl;
			}
		}
	}
}
