
#include <iostream>
#include <cmath>
#include <numeric>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

int ans = -1;
vector<string> ans_names;

vector<string> names;
	vector<int> sizes;
	vector<int> calls;
	int n;

void gen(int current_weight, int current_sum, int max_weight, vector<string> cur_names, int index) {
	
	if (current_weight > max_weight) {
		return;
	}
	if (current_sum > ans) {
		ans_names = cur_names;
		ans = current_sum;
	}
	for (int i = index + 1; i < n; ++i) {
		cur_names.push_back(names[i]);
		gen(current_weight + sizes[i], current_sum + calls[i], max_weight, cur_names, i);
		cur_names.pop_back();
	}
}

int main() {
	int m, x;
	cin >> n >> m >> x;
	map<string, int> mp;
	names.resize(n);
	sizes.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> names[i] >> sizes[i];
		mp[names[i]] = 0;
	}
	for (int i = 0; i < m; ++i) {
		string s;
		cin >> s;
		vector<string> used_names;
		while (!(s[0] >= '0' && s[0] <= '9')) {
			used_names.push_back(s);
			cin >> s;
		}
		int k = stoi(s);
		for (auto& el : used_names) {
			mp[el] += k;
		}
	}
	calls.resize(n, 0);
	for (auto& el : mp) {
		int i;
		for (i = 0; i < n; ++i) {
			if (names[i] == el.first) {
				break;
			}
		}
		calls[i] = el.second;
	}
	gen(0, 0, x, {}, -1);
	
	cout << ans_names.size() << '\n';
	for (auto& el : ans_names) {
		cout << el << '\n';
	}
    return 0;
}
